/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggVorbis SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS LIBRARY SOURCE IS     *
 * GOVERNED BY A BSD-STYLE SOURCE LICENSE INCLUDED WITH THIS SOURCE *
 * IN 'COPYING'. PLEASE READ THESE TERMS BEFORE DISTRIBUTING.       *
 *                                                                  *
 * THE OggVorbis SOURCE CODE IS (C) COPYRIGHT 1994-2002             *
 * by the Xiph.Org Foundation http://www.xiph.org/                  *
 *                                                                  *
 ********************************************************************

 function: #ifdef jail to whip a few platforms into the UNIX ideal.
 last mod: $Id: os_types.h,v 1.14 2003/09/02 05:09:14 xiphmont Exp $

 ********************************************************************/
/*Modified for libmusepack purposes*/

#ifndef _OS_TYPES_H
#define _OS_TYPES_H

/* make it easy on the folks that want to compile the libs with a
   different malloc than stdlib */
#define _mpc_malloc  malloc
#define _mpc_calloc  calloc
#define _mpc_realloc realloc
#define _mpc_free    free


#ifdef _WIN32 

#  ifndef __GNUC__
   /* MSVC/Borland */
   typedef __int64 mpc_int64_t;
   typedef __int32 mpc_int32_t;
   typedef unsigned __int32 mpc_uint32_t;
   typedef __int16 mpc_int16_t;
   typedef unsigned __int16 mpc_uint16_t;
#  else
   /* Cygwin */
   #include <_G_config.h>
   typedef _G_int64_t mpc_int64_t;
   typedef _G_int32_t mpc_int32_t;
   typedef _G_uint32_t mpc_uint32_t;
   typedef _G_int16_t mpc_int16_t;
   typedef _G_uint16_t mpc_uint16_t;
#  endif

#elif defined(__MACOS__)

#  include <sys/types.h>
   typedef SInt16 mpc_int16_t;
   typedef UInt16 mpc_uint16_t;
   typedef SInt32 mpc_int32_t;
   typedef UInt32 mpc_uint32_t;
   typedef SInt64 mpc_int64_t;

#elif defined(__MACOSX__) /* MacOS X Framework build */

#  include <sys/types.h>
   typedef int16_t mpc_int16_t;
   typedef u_int16_t mpc_uint16_t;
   typedef int32_t mpc_int32_t;
   typedef u_int32_t mpc_uint32_t;
   typedef int64_t mpc_int64_t;

#elif defined(__BEOS__)

   /* Be */
#  include <inttypes.h>
   typedef int16_t mpc_int16_t;
   typedef u_int16_t mpc_uint16_t;
   typedef int32_t mpc_int32_t;
   typedef u_int32_t mpc_uint32_t;
   typedef int64_t mpc_int64_t;

#elif defined (__EMX__)

   /* OS/2 GCC */
   typedef short mpc_int16_t;
   typedef unsigned short mpc_uint16_t;
   typedef int mpc_int32_t;
   typedef unsigned int mpc_uint32_t;
   typedef long long mpc_int64_t;

#elif defined (DJGPP)

   /* DJGPP */
   typedef short mpc_int16_t;
   typedef int mpc_int32_t;
   typedef unsigned int mpc_uint32_t;
   typedef long long mpc_int64_t;

#elif defined(R5900)

   /* PS2 EE */
   typedef long mpc_int64_t;
   typedef int mpc_int32_t;
   typedef unsigned mpc_uint32_t;
   typedef short mpc_int16_t;

#else

#  include <sys/types.h>
typedef int16_t mpc_int16_t;
typedef u_int16_t mpc_uint16_t;
typedef int32_t mpc_int32_t;
typedef u_int32_t mpc_uint32_t;
typedef int64_t mpc_int64_t;

#endif

#endif  /* _OS_TYPES_H */
